apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "pinfo4.fullname" . }}.job-service
  namespace: {{ .Release.Namespace }} 
  labels:
    {{- include "pinfo4.labels" . | nindent 4 }}
    {{- include "pinfo4.labels" . | nindent 4 }}.job-service
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "pinfo4.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        app: {{ include "pinfo4.fullname" . }}.job-service
        {{- include "pinfo4.selectorLabels" . | nindent 8 }}
    spec:
    {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      serviceAccountName: {{ include "pinfo4.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      initContainers:
         - name: check-db-ready
           image: postgres:12.1-alpine
           command: ['sh', '-c', 
             'until pg_isready -h {{ .Release.Name }}-{{ .Values.job.datasource.service }} -p {{ .Values.job.datasource.port }}; 
             do echo waiting for database; sleep 2; done;']                   
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: {{ .Values.image.repository }}/{{ .Values.image.group}}/job-service:{{ .Values.image.tag }}
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          env:
            - name: QUARKUS_DATASOURCE_JDBC_URL
              value: "jdbc:postgresql://{{ .Release.Name }}-{{ .Values.job.datasource.service }}:{{ .Values.job.datasource.port }}/{{ .Values.job.datasource.database }}"
            - name: QUARKUS_DATASOURCE_USERNAME
              value: {{ .Values.job.datasource.username }}
            - name: QUARKUS_DATASOURCE_PASSWORD
              value: {{ .Values.job.datasource.password }}
            - name: KAFKA_BOOTSTRAP_SERVERS
              value: "{{ .Release.Name }}-{{ .Values.articles.kafka.service.name }}:{{ .Values.articles.kafka.service.port }}"
            - name: QUARKUS_HTTP_CORS
              value: "{{ .Values.cors.enable }}"
          ports:
            - name: http
              containerPort: 8080
              protocol: TCP
              # livenessProbe:
              # httpGet:
              # path: /articles/count
              # port: 8080
              # initialDelaySeconds: 60
              # periodSeconds: 20                            
              # readinessProbe:
              # httpGet:
              # path: /instrument/count
              # port: 8080
              # initialDelaySeconds: 60
              # periodSeconds: 20                            
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
